-- ------------------------------------------
--  Linear Feedback Shift Register
-- ------------------------------------------
--

LIBRARY ieee;
  USE ieee.std_logic_1164.ALL;

-- ------------------------------------------
    Entity LFSREG is
-- ------------------------------------------
      Port (     CLK : In    std_logic;
                   D : In    std_logic_vector (7 downto 0);
                  EN : In    std_logic;
                  LD : In    std_logic;
                 RST : In    std_logic;
                   Q : Out   std_logic_vector (7 downto 0) );
end LFSREG;


-- ------------------------------------------
    Architecture RTL of LFSREG is
-- ------------------------------------------

signal QI : std_logic_vector (7 downto 0);

begin

Q <= QI;

process (CLK,RST)
begin
  if (RST='1') then
    QI <= (others=>'0');
  elsif rising_edge(CLK) then
    if (LD='1') then
      QI <= D;
    elsif (EN='1') then
      QI <= QI (6 downto 0) & not (QI(3) xor QI(4) xor QI(5) xor QI(7));
      -- the inverter makes sure we don't get stuck at 00 (reset value)
    end if;
  end if;
end process;

end RTL;

